import{s as Ae,n as Xe,o as Fe}from"../chunks/scheduler.d627b047.js";import{S as We,i as Ye,g as a,s as n,r as p,A as ze,h as s,f as l,c as o,j as Oe,u as h,x as r,k as Ve,y as Be,a as i,v as c,d as m,t as d,w as f}from"../chunks/index.73c51727.js";import{C as xe}from"../chunks/CodeBlock.b1cdc5f6.js";import{H as W,E as De}from"../chunks/EditOnGithub.859b9ebc.js";function Ne(Te){let u,B,Y,D,g,N,b,J,w,_e="The examples should work in any of the following settings (with the same script):",E,y,$e="<li>single GPU</li> <li>multi GPUS (using PyTorch distributed mode)</li> <li>multi GPUS (using DeepSpeed ZeRO-Offload stages 1, 2, &amp; 3)</li> <li>fp16 (mixed-precision), fp32 (normal precision), or bf16 (bfloat16 precision)</li>",I,x,ve=`To run it in each of these various modes, first initialize the accelerate
configuration with <code>accelerate config</code>`,q,T,Me="<strong>NOTE to train with a 4-bit or 8-bit model</strong>, please run",Q,_,K,$,ee,v,Pe="For all the examples, you’ll need to generate a 🤗 Accelerate config file with:",te,M,le,P,Ue="Then, it is encouraged to launch jobs with <code>accelerate launch</code>!",ie,U,ne,C,Ce='Scripts can be used as examples of how to use TRL trainers. They are located in the <a href="https://github.com/huggingface/trl/blob/main/trl/scripts" rel="nofollow"><code>trl/scripts</code></a> directory. Additionally, we provide examples in the <a href="https://github.com/huggingface/trl/blob/main/examples/scripts" rel="nofollow"><code>examples/scripts</code></a> directory. These examples are maintained and tested regularly.',oe,L,Le='<thead><tr><th>File</th> <th>Description</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/alignprop.py" rel="nofollow"><code>examples/scripts/alignprop.py</code></a></td> <td>This script shows how to use the <code>AlignPropTrainer</code> to fine-tune a diffusion model.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/bco.py" rel="nofollow"><code>examples/scripts/bco.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/kto_trainer#trl.KTOTrainer">KTOTrainer</a> with the BCO loss to fine-tune a model to increase instruction-following, truthfulness, honesty and helpfulness using the <a href="https://huggingface.co/datasets/openbmb/UltraFeedback" rel="nofollow">openbmb/UltraFeedback</a> dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/cpo.py" rel="nofollow"><code>examples/scripts/cpo.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/cpo_trainer#trl.CPOTrainer">CPOTrainer</a> to fine-tune a model to increase helpfulness and harmlessness using the <a href="https://huggingface.co/datasets/Anthropic/hh-rlhf" rel="nofollow">Anthropic/hh-rlhf</a> dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ddpo.py" rel="nofollow"><code>examples/scripts/ddpo.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/ddpo_trainer#trl.DDPOTrainer">DDPOTrainer</a> to fine-tune a stable diffusion model using reinforcement learning.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/dpo_vlm.py" rel="nofollow"><code>examples/scripts/dpo_vlm.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/dpo_trainer#trl.DPOTrainer">DPOTrainer</a> to fine-tune a Vision Language Model to reduce hallucinations using the <a href="https://huggingface.co/datasets/openbmb/RLAIF-V-Dataset" rel="nofollow">openbmb/RLAIF-V-Dataset</a> dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/orpo.py" rel="nofollow"><code>examples/scripts/orpo.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/orpo_trainer#trl.ORPOTrainer">ORPOTrainer</a> to fine-tune a model to increase helpfulness and harmlessness using the <a href="https://huggingface.co/datasets/Anthropic/hh-rlhf" rel="nofollow">Anthropic/hh-rlhf</a> dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ppo/ppo.py" rel="nofollow"><code>examples/scripts/ppo/ppo.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/ppo_trainer#trl.PPOTrainer">PPOTrainer</a> to fine-tune a model to improve its ability to continue text with positive sentiment or physically descriptive language</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/ppo/ppo_tldr.py" rel="nofollow"><code>examples/scripts/ppo/ppo_tldr.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/ppo_trainer#trl.PPOTrainer">PPOTrainer</a> to fine-tune a model to improve its ability to generate TL;DR summaries.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/reward_modeling.py" rel="nofollow"><code>examples/scripts/reward_modeling.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/reward_trainer#trl.RewardTrainer">RewardTrainer</a> to train a reward model on your own dataset.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/blob/main/examples/scripts/sft_vlm.py" rel="nofollow"><code>examples/scripts/sft_vlm.py</code></a></td> <td>This script shows how to use the <a href="/docs/trl/main/en/sft_trainer#trl.SFTTrainer">SFTTrainer</a> to fine-tune a Vision Language Model in a chat setting. The script has only been tested with <a href="https://huggingface.co/llava-hf/llava-1.5-7b-hf" rel="nofollow">LLaVA 1.5</a>, <a href="https://huggingface.co/llava-hf/llava-v1.6-mistral-7b-hf" rel="nofollow">LLaVA 1.6</a>, and <a href="https://huggingface.co/meta-llama/Llama-3.2-11B-Vision-Instruct" rel="nofollow">Llama-3.2-11B-Vision-Instruct</a> models so users may see unexpected behaviour in other model architectures.</td></tr></tbody>',ae,G,Ge="Here are also some easier-to-run colab notebooks that you can use to get started with TRL:",se,R,Re='<thead><tr><th>File</th> <th>Description</th></tr></thead> <tbody><tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/best_of_n.ipynb" rel="nofollow"><code>examples/notebooks/best_of_n.ipynb</code></a></td> <td>This notebook demonstrates how to use the “Best of N” sampling strategy using TRL when fine-tuning your model with PPO.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/gpt2-sentiment.ipynb" rel="nofollow"><code>examples/notebooks/gpt2-sentiment.ipynb</code></a></td> <td>This notebook demonstrates how to reproduce the GPT2 imdb sentiment tuning example on a jupyter notebook.</td></tr> <tr><td><a href="https://github.com/huggingface/trl/tree/main/examples/notebooks/gpt2-control.ipynb" rel="nofollow"><code>examples/notebooks/gpt2-control.ipynb</code></a></td> <td>This notebook demonstrates how to reproduce the GPT2 sentiment control example on a jupyter notebook.</td></tr></tbody>',re,H,He="We also have some other examples that are less maintained but can be used as a reference:",pe,Z,Ze='<li><strong><a href="https://github.com/huggingface/trl/tree/main/examples/research_projects" rel="nofollow">research_projects</a></strong>: Check out this folder to find the scripts used for some research projects that used TRL (LM de-toxification, Stack-Llama, etc.)</li>',he,k,ce,S,ke="All of the scripts can be run on multiple GPUs by providing the path of an 🤗 Accelerate config file when calling <code>accelerate launch</code>. To launch one of them on one or multiple GPUs, run the following command (swapping <code>{NUM_GPUS}</code> with the number of GPUs in your machine and <code>--all_arguments_of_the_script</code> with your arguments.)",me,j,de,O,Se="You can also adjust the parameters of the 🤗 Accelerate config file to suit your needs (e.g. training in mixed precision).",fe,V,ue,A,je="Most of the scripts can be run on multiple GPUs together with DeepSpeed ZeRO-{1,2,3} for efficient sharding of the optimizer states, gradients, and model weights. To do so, run following command (swapping <code>{NUM_GPUS}</code> with the number of GPUs in your machine, <code>--all_arguments_of_the_script</code> with your arguments, and <code>--deepspeed_config</code> with the path to the DeepSpeed config file such as <code>examples/deepspeed_configs/deepspeed_zero1.yaml</code>):",ge,X,be,F,we,z,ye;return g=new W({props:{title:"Examples",local:"examples",headingTag:"h1"}}),b=new W({props:{title:"Introduction",local:"introduction",headingTag:"h2"}}),_=new xe({props:{code:"cGlwJTIwaW5zdGFsbCUyMC0tdXBncmFkZSUyMHRybCU1QnF1YW50aXphdGlvbiU1RA==",highlighted:"pip install --upgrade trl[quantization]",wrap:!1}}),$=new W({props:{title:"Accelerate Config",local:"accelerate-config",headingTag:"h2"}}),M=new xe({props:{code:"YWNjZWxlcmF0ZSUyMGNvbmZpZyUyMCUyMyUyMHdpbGwlMjBwcm9tcHQlMjB5b3UlMjB0byUyMGRlZmluZSUyMHRoZSUyMHRyYWluaW5nJTIwY29uZmlndXJhdGlvbg==",highlighted:"accelerate config # will prompt you to define the training configuration",wrap:!1}}),U=new W({props:{title:"Maintained Examples",local:"maintained-examples",headingTag:"h1"}}),k=new W({props:{title:"Distributed training",local:"distributed-training",headingTag:"h2"}}),j=new xe({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMC0tY29uZmlnX2ZpbGUlM0RleGFtcGxlcyUyRmFjY2VsZXJhdGVfY29uZmlncyUyRm11bHRpX2dwdS55YW1sJTIwLS1udW1fcHJvY2Vzc2VzJTIwJTdCTlVNX0dQVVMlN0QlMjBwYXRoX3RvX3NjcmlwdC5weSUyMC0tYWxsX2FyZ3VtZW50c19vZl90aGVfc2NyaXB0",highlighted:"accelerate launch --config_file=examples/accelerate_configs/multi_gpu.yaml --num_processes {NUM_GPUS} path_to_script.py --all_arguments_of_the_script",wrap:!1}}),V=new W({props:{title:"Distributed training with DeepSpeed",local:"distributed-training-with-deepspeed",headingTag:"h3"}}),X=new xe({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMC0tY29uZmlnX2ZpbGUlM0RleGFtcGxlcyUyRmFjY2VsZXJhdGVfY29uZmlncyUyRmRlZXBzcGVlZF96ZXJvJTdCMSUyQzIlMkMzJTdELnlhbWwlMjAtLW51bV9wcm9jZXNzZXMlMjAlN0JOVU1fR1BVUyU3RCUyMHBhdGhfdG9fc2NyaXB0LnB5JTIwLS1hbGxfYXJndW1lbnRzX29mX3RoZV9zY3JpcHQ=",highlighted:"accelerate launch --config_file=examples/accelerate_configs/deepspeed_zero{1,2,3}.yaml --num_processes {NUM_GPUS} path_to_script.py --all_arguments_of_the_script",wrap:!1}}),F=new De({props:{source:"https://github.com/huggingface/trl/blob/main/docs/source/example_overview.md"}}),{c(){u=a("meta"),B=n(),Y=a("p"),D=n(),p(g.$$.fragment),N=n(),p(b.$$.fragment),J=n(),w=a("p"),w.textContent=_e,E=n(),y=a("ul"),y.innerHTML=$e,I=n(),x=a("p"),x.innerHTML=ve,q=n(),T=a("p"),T.innerHTML=Me,Q=n(),p(_.$$.fragment),K=n(),p($.$$.fragment),ee=n(),v=a("p"),v.textContent=Pe,te=n(),p(M.$$.fragment),le=n(),P=a("p"),P.innerHTML=Ue,ie=n(),p(U.$$.fragment),ne=n(),C=a("p"),C.innerHTML=Ce,oe=n(),L=a("table"),L.innerHTML=Le,ae=n(),G=a("p"),G.textContent=Ge,se=n(),R=a("table"),R.innerHTML=Re,re=n(),H=a("p"),H.textContent=He,pe=n(),Z=a("ol"),Z.innerHTML=Ze,he=n(),p(k.$$.fragment),ce=n(),S=a("p"),S.innerHTML=ke,me=n(),p(j.$$.fragment),de=n(),O=a("p"),O.textContent=Se,fe=n(),p(V.$$.fragment),ue=n(),A=a("p"),A.innerHTML=je,ge=n(),p(X.$$.fragment),be=n(),p(F.$$.fragment),we=n(),z=a("p"),this.h()},l(e){const t=ze("svelte-u9bgzb",document.head);u=s(t,"META",{name:!0,content:!0}),t.forEach(l),B=o(e),Y=s(e,"P",{}),Oe(Y).forEach(l),D=o(e),h(g.$$.fragment,e),N=o(e),h(b.$$.fragment,e),J=o(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1qml164"&&(w.textContent=_e),E=o(e),y=s(e,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-y1bwso"&&(y.innerHTML=$e),I=o(e),x=s(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1gk4czs"&&(x.innerHTML=ve),q=o(e),T=s(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1uwpnnm"&&(T.innerHTML=Me),Q=o(e),h(_.$$.fragment,e),K=o(e),h($.$$.fragment,e),ee=o(e),v=s(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-8m9xl"&&(v.textContent=Pe),te=o(e),h(M.$$.fragment,e),le=o(e),P=s(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1fatpmt"&&(P.innerHTML=Ue),ie=o(e),h(U.$$.fragment,e),ne=o(e),C=s(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-7eac1h"&&(C.innerHTML=Ce),oe=o(e),L=s(e,"TABLE",{"data-svelte-h":!0}),r(L)!=="svelte-12i3wsv"&&(L.innerHTML=Le),ae=o(e),G=s(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-8xuvqq"&&(G.textContent=Ge),se=o(e),R=s(e,"TABLE",{"data-svelte-h":!0}),r(R)!=="svelte-17wv7zp"&&(R.innerHTML=Re),re=o(e),H=s(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-nr1j2l"&&(H.textContent=He),pe=o(e),Z=s(e,"OL",{"data-svelte-h":!0}),r(Z)!=="svelte-ks8v1x"&&(Z.innerHTML=Ze),he=o(e),h(k.$$.fragment,e),ce=o(e),S=s(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1wqljqa"&&(S.innerHTML=ke),me=o(e),h(j.$$.fragment,e),de=o(e),O=s(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-12yw9zf"&&(O.textContent=Se),fe=o(e),h(V.$$.fragment,e),ue=o(e),A=s(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-155h86t"&&(A.innerHTML=je),ge=o(e),h(X.$$.fragment,e),be=o(e),h(F.$$.fragment,e),we=o(e),z=s(e,"P",{}),Oe(z).forEach(l),this.h()},h(){Ve(u,"name","hf:doc:metadata"),Ve(u,"content",Je)},m(e,t){Be(document.head,u),i(e,B,t),i(e,Y,t),i(e,D,t),c(g,e,t),i(e,N,t),c(b,e,t),i(e,J,t),i(e,w,t),i(e,E,t),i(e,y,t),i(e,I,t),i(e,x,t),i(e,q,t),i(e,T,t),i(e,Q,t),c(_,e,t),i(e,K,t),c($,e,t),i(e,ee,t),i(e,v,t),i(e,te,t),c(M,e,t),i(e,le,t),i(e,P,t),i(e,ie,t),c(U,e,t),i(e,ne,t),i(e,C,t),i(e,oe,t),i(e,L,t),i(e,ae,t),i(e,G,t),i(e,se,t),i(e,R,t),i(e,re,t),i(e,H,t),i(e,pe,t),i(e,Z,t),i(e,he,t),c(k,e,t),i(e,ce,t),i(e,S,t),i(e,me,t),c(j,e,t),i(e,de,t),i(e,O,t),i(e,fe,t),c(V,e,t),i(e,ue,t),i(e,A,t),i(e,ge,t),c(X,e,t),i(e,be,t),c(F,e,t),i(e,we,t),i(e,z,t),ye=!0},p:Xe,i(e){ye||(m(g.$$.fragment,e),m(b.$$.fragment,e),m(_.$$.fragment,e),m($.$$.fragment,e),m(M.$$.fragment,e),m(U.$$.fragment,e),m(k.$$.fragment,e),m(j.$$.fragment,e),m(V.$$.fragment,e),m(X.$$.fragment,e),m(F.$$.fragment,e),ye=!0)},o(e){d(g.$$.fragment,e),d(b.$$.fragment,e),d(_.$$.fragment,e),d($.$$.fragment,e),d(M.$$.fragment,e),d(U.$$.fragment,e),d(k.$$.fragment,e),d(j.$$.fragment,e),d(V.$$.fragment,e),d(X.$$.fragment,e),d(F.$$.fragment,e),ye=!1},d(e){e&&(l(B),l(Y),l(D),l(N),l(J),l(w),l(E),l(y),l(I),l(x),l(q),l(T),l(Q),l(K),l(ee),l(v),l(te),l(le),l(P),l(ie),l(ne),l(C),l(oe),l(L),l(ae),l(G),l(se),l(R),l(re),l(H),l(pe),l(Z),l(he),l(ce),l(S),l(me),l(de),l(O),l(fe),l(ue),l(A),l(ge),l(be),l(we),l(z)),l(u),f(g,e),f(b,e),f(_,e),f($,e),f(M,e),f(U,e),f(k,e),f(j,e),f(V,e),f(X,e),f(F,e)}}}const Je='{"title":"Examples","local":"examples","sections":[{"title":"Introduction","local":"introduction","sections":[],"depth":2},{"title":"Accelerate Config","local":"accelerate-config","sections":[],"depth":2}],"depth":1}';function Ee(Te){return Fe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class et extends We{constructor(u){super(),Ye(this,u,Ee,Ne,Ae,{})}}export{et as component};
